--##****************************************************
--##**	   SUPREME ART OF DEFENCE		             **
--##**	              SCRIPT  BY SAYA                            **
--##**		    MAP BY SCHLOOBER                      **
--##**		    DESIGN BY EDMON                       **
--##**	                   V 1.1 ALPHA                                       **
--##****************************************************


--scenario utilities
local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')
local ScenarioFramework = import('/lua/ScenarioFramework.lua')
local Utilities = import('/lua/utilities.lua')

--interface utilities
local UIUtil = import('/lua/ui/uiutil.lua')
local gameParent = import('/lua/ui/game/gamemain.lua').GetGameParent()

--ScenarioInfo.Options.FogOfWar = 'explored'
	
--PLAYERS, CONTAINS USEFUL INFO FOR THE SCRIPT FOR EACH PLAYER
local playersDATA = {
	['player1'] = {
		name = 'player1', 
		defeated = false,
		score = 0,
		column = 1,
		enemy = 'enemy1',
		ai = false,
	},
	['player2'] = {
		name = 'player2', 
		defeated = false,
		score = 0,
		column = 2,
		enemy = 'enemy2',
		ai = false,
	},
	['player3'] = {
		name = 'player3',
		defeated = false,
		score = 0,
		column = 3,
		enemy = 'enemy3',
		ai = false,
	},
	['player4'] = {
		name = 'player4', 
		defeated = false,
		score = 0,
		column = 4,
		enemy = 'enemy4',
		ai = false,
	},
	['enemy1'] = {
		name = 'enemy1', 
		defeated = false,
		score = 0,
		column = 1,
		ai = true,
		color = {170,120,10},
	},
	['enemy2'] = {
		name = 'enemy2', 
		defeated = false,
		score = 0,
		column = 2,
		ai = true,
		color = {50,150,180},
	},
	['enemy3'] = {
		name = 'enemy3', 
		defeated = false,
		score = 0,
		column = 3,
		ai = true,
		color = {180,200,80},
	},
	['enemy4'] = {
		name = 'enemy4', 
		defeated = false,
		score = 0,
		column = 4,
		ai = true,
		color = {120,100,100},
	},
}

local players = {}

local armyTable = {
	 ['ARMY_1'] = 'player1',
	 ['ARMY_2'] = 'player2',
	 ['ARMY_3'] = 'player3',
	 ['ARMY_4'] = 'player4',
	 ['ARMY_9'] = 'enemy1',
	 ['ARMY_10'] = 'enemy2',
	 ['ARMY_11'] = 'enemy3',
	 ['ARMY_12'] = 'enemy4',
}


--scenario variables
local gameEnd = false
local waveEnd = false
local beatTime = 1
local beat = 0
local waveid = 1
local buildTime = 12
local loop = 0

--map size
local xmapsize = 510
local ymapsize = 510

--first parameter of a wave is duration in seconds, it is the time before the next wave
--second parameter is the composition of the wave, it is made up of one to many unit sets
--the first parameter of a unit set is the unittype, the second is the number of units and the last
--is the spawn location. the two possibilities are "top" and "middle". nothing will be interpreted as "middle".
--upgrades is used for scus to spawn a scu with upgrades
local waves = {
	{duration = 180, composition = {{'uel0201',20,"top"},}, },
	{duration = 180, composition = {{'UEL0103',5},{'URL0202',5}}, },
	{duration = 130, composition = {{'UAA0103',10,"top"},},},--{'UAA0102',10}}, },
	{duration = 5, composition = {{'uea0305',2,"top"},{'uea0303',2,"top"}}, },
	{duration = 130, composition = {{'uel0202',10},{'uel0103',10},{'uel0104',10}}, },
	{duration = 5, composition = {{'urs0201',4,"top"},{'uel0307',4,"top"}}, },
	{duration = 120, composition = {{'uel0202',11},{'uel0111',5},{'uel0205',8}}, },
	{duration = 120, composition = {{'uea0203',10,"top"},{'UAA0102',10,"top"}}, },
	{duration = 120, composition = {{'uel0303',10},{'uel0304',3},{'uel0104',20}}, },
	{duration = 120, composition = {{'url0303',20},{'url0111',10},{'url0104',20}}, },
	{duration = 20, composition = {{'urs0201',5,"top"},{'uel0307',6,"top"}}, },
	{duration = 120, composition = {{'uea0304',3,"top"},{'UAA0102',6,"top"}}, },
	{duration = 120, composition = {{'uel0202',30},{'uel0111',20},{'uel0205',15}}, },
	{duration = 5, composition = {{'url0402',2,"top"}}, },
	{duration = 5, composition = {{'uea0305',4,"top"},{'uea0303',20,"top"}}, },
	{duration = 120, composition = {{'url0202',20},{'uel0111',15},{'uel0205',20}}, },
	{duration = 120, composition = {{'ura0203',20,"top"},{'ura0303',30,"top"}}, },
	{duration = 120, composition = {{'url0303',30},{'url0111',15},{'url0205',20}}, },
	{duration = 5, composition = {{'uea0305',2,"top"},{'uea0303',2,"top"}}, },
	{duration = 5, composition = {{'ual0202',20,"top"},{'uaa0303',40,"top"}}, },
	{duration = 120, composition = {{'url0303',30},{'uel0307',10},{'ual0205',10}}, },
	{duration = 120, composition = {{'uea0304',6,"top"},{'UAA0102',30,"top"}}, },
	{duration = 120, composition = {{'url0301',5,upgrades = {'NaniteMissileSystem'}},}, }, 
	{duration = 120, composition = {{'ual0301',6},{'ual0205',20},}, },
	{duration = 30, composition = {{'url0402',3,"top"}}, },
	{duration = 5, composition = {{'ura0401',3,"top"}}, },
	{duration = 10, composition = {{'uel0401',3,"top"}}, },
	{duration = 5, composition = {{'ual0401',3,"top"}}, },
	{duration = 60, composition = {{'uea0305',30,"top"},{'uea0303',40,"top"}}, },
	{duration = 60, composition = {{'ueb2401',1,"top"}}, },
	{duration = 60, composition = {{'uea0305',30,"top"},{'uea0303',40,"top"}}, },

}

--here are the top spawn location and the middle spawn location
local top = 20
local middle = 220



--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~UTILITY FUNCTIONS~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

--given a player returns an army
toArmy = function(player)
	local army = false
	for i,v in armyTable do
		if v == player.name then
			army = i
		end
	end
	return army
end


--given a player returns a proper username
username = function(player)
	return GetArmyBrain(toArmy(player)).Nickname
end

--given a player returns the number of kills
armyKills = function(player)
	local kills = 0
	if player.name != 'neutral' then 
		local army = toArmy(player)
		kills = GetArmyBrain(army):GetArmyStat('Enemies_Killed',0.0).Value 
	end
	return kills	
end

--print a text scn way :p
--first arg is the text to print
--second arg is what player it concerns
--third arg is if it has to be printed to that player only or to all players
scnPrint = function(text,player,playeronly)

	local army = toArmy(player)
	local colorIndex = ScenarioInfo.ArmySetup[army].PlayerColor
	local color = import('/lua/GameColors.lua').GameColors.ArmyColors[colorIndex]
	
	if not playeronly then
		playerspecific = false
	else
		playerspecific = playeronly
	end
	
	
	if playerspecific == true then
		if army == indexToArmy(GetFocusArmy()) then
			PrintText(text,20,color,5,'center') 
		end
	else
		PrintText(text,20,color,5,'center') 
	end
end

fastPrint = function(text)
	PrintText(text,20,nil,5,'center') 		
end

--given a unit returns the army
scnArmy = function(unit)
	local armyIndex = unit:GetArmy()
	return indexToArmy(armyIndex)
end

--given an army index returns an army
indexToArmy = function(armyIndex)
	local army = ListArmies()[armyIndex]
	return army
end

--given an army return its index
armyToIndex = function(army)
	for i,v in ListArmies() do
		if v == army then
			return i 
		end
	end
end

--get the number of players
playerCount = function()
	local i = 0
	for index, player in players do
		i = i + 1
	end
	return i
end


--given an ai brain returns an army index
function ArmyIndexer(aiBrain)
	local tblArmy = ListArmies()
	local army = tblArmy[aiBrain:GetArmyIndex()]
	for i, v in armyTable do
		if i == army then
			return v
		end
	end
end

--given an army returns a player
function toPlayer(army)
	return players[armyTable[army]]
end

--given a player return the enemy
function enemy(player)
	return players[player.enemy]
end
--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~MAIN SCRIPT FUNCTIONS~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

--populating
function OnPopulate()
	
	InitializeArmies()
	initialiseAlliances()
    --ScenarioFramework.SetPlayableArea('Playfield', false)
	import('/lua/SimUtils.lua').GiveUnitsToPlayer = function() end	
	import('/lua/SimUtils.lua').SetResourceSharing = function() end
	
end


--start of map script
function OnStart(self)

	-- force victory condition to sandbox
	--ScenarioInfo.Options.Victory = 'demoralization'
	ScenarioInfo.Options.Victory = 'sandbox'
	
	-- set score calculation to show total kills
	for index, brain in ArmyBrains do
	   brain.CalculateScore = function(thisBrain)
		   local score = players[ArmyIndexer(thisBrain)].score
		   return score 
	   end
	end 
	
   
	--initialise scenario
	--ScenarioFramework.SetPlayableArea('Playfield', false)
	Utilities.UserConRequest("ui_ForceLifbarsOnEnemy")--show enemy life bars
	
	--spawn computer towers and so on
	spawnStartUnits()
	
	--start the different scenario threads
	startScenarioThreads()
end

--creates the different threads 
startScenarioThreads = function()
	--start main thread
	local mainThread = ForkThread(function(self)
		while gameEnd == false do
			--wait time between each beat
			WaitSeconds(beatTime)
			--call main thread beat
			updateDATA()
			--increment beat count
			beat = beat + 1
		end
		KillThread(self)
    end)
	
	--spawning a new wave only depends on time
	--this creates a new thread for each human  player
	local spawnThread = ForkThread( function(self)
		--some time to let everybody build up  a little
		WaitSeconds(buildTime)
		
		--start sending the waves!
		while true do 
			while waveEnd == false do
			
				--if the wave exists
				if waveid <= table.getn(waves) then
				
					--spawn wave				
					--LOG("sending in	wave number: " .. waveid)
					for index,player in players do
						if player.ai == false then
							if player.defeated == false then
								spawnWave(player)					
							end			
						end
					end			

					--wait time until next wave
					WaitSeconds(getWave().duration)
					waveid = waveid+1
					
				else
					waveEnd = true
				end
			
			end
		--game never ends, once all rounds are done increase difficulty and restart rounds
		waveid = 1
		loop = loop + 1
		waveEnd = false
		end
		
		--no more waves to send, kill thread
		--Victory?
		KillThread(self)
	end)
	
	

end

--MAIN SCENARIO THREAD
--do map script actions every TICK
updateDATA = function()
	for i, player in players do
		if player.defeated == false and player.ai == false then
			player.score = beat
		end
	end
	copyPlayerInfo()
end


--copy the map script variables into the aibrains so that the zone control ai can use them
copyPlayerInfo = function()
	for i, player in players do
		GetArmyBrain(toArmy(player)).SAODnfo = table.copy(players)
	end
end


--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~WAVE MANAGEMENT~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

--returns the current wave
getWave = function()
	return waves[waveid]
end

--returns the columns left right and middle
column = function(player)
	local left = ( player.column - 1 )*(126) + 12
	local right = left + 108
	local middle = (left + right)/2 
	return {left,right,middle}
end

--given a player spawn its current wave
spawnWave = function(player)
	local wave = getWave()
	local aiBrain = GetArmyBrain(toArmy(player))
	local topunits = {}
	local middleunits = {}
	
	if wave != false then	
		fastPrint("Prepare for wave " .. waveid .. "!")

		local column = column(player)
		
		local j = 1
		for index,unitset in wave.composition do
			local i = 1
			
			--determine spawn position of the unit set
			local spawnposition = false
			if unitset[3] then
				if unitset[3] == "middle" then 
					spawnposition = middle
				elseif unitset[3] == "top" then
					spawnposition = top
				end
			else
				spawnposition = middle
			end
			
			--spawn units
			while i <= unitset[2] do	
				local x = column[1] + 30
				local y = spawnposition + j*5
				
				--calculate formation position of unit
				local rowposition = math.mod(i,12)*5
				local lineposition = math.ceil(i/12)*5
				
				--spawn unit
				local unit = false
				if GetArmyUnitCostTotal(GetArmyBrain(toArmy(enemy(player))):GetArmyIndex()) < GetArmyUnitCap(GetArmyBrain(toArmy(enemy(player))):GetArmyIndex()) then
					unit = CreateUnitHPR( unitset[1], toArmy(enemy(player)), rowposition + x,64, lineposition + y, 0,0,0) 			
				end
				
				--apply upgrades if necessary
				if unitset.upgrades then 
					for i,enhancement in unitset.upgrades do
						unit:CreateEnhancement(enhancement)
					end
				end
				
				--apply buffs for looped rounds
				if loop > 0 then
					unit:SetMaxHealth(unit:GetHealth()*4*loop)
					unit:SetHealth(nil,unit:GetHealth()*4*loop)
					for i = 1, unit:GetWeaponCount() do
						unit:GetWeapon(i):ChangeRateOfFire(1 + loop)
					end
				end
				
				--assign the unit to the right unit platoon
				if unit != false then
					if not unitset[3] or unitset[3] == "middle" then 						
						table.insert(topunits,unit) 
					elseif unitset[3] == "top" then
						table.insert(middleunits,unit)
					end
				end
				
				i = i + 1
			end
			j = j + 1
		end		
		
		--give orders
		attackPlayer(topunits,player)
		attackPlayer(middleunits,player)

	end
	
end


--forms a platoon to attack a player with a given set of units
attackPlayer = function(units,player)	
	local aiBrain = GetArmyBrain(toArmy(player))
	if table.getn(units) > 0 then
		local attackPlatoon = aiBrain:MakePlatoon('','')
		aiBrain:AssignUnitsToPlatoon(attackPlatoon, units, 'Attack', 'GrowthFormation')
		attackPlatoon:AggressiveMoveToLocation({column(player)[3],64,ymapsize - 10})
	end
end

--adds a kill count to a unit used to know when to spawn the next wave
addKilledCount = function(unit)
	unit.OldOnKilled = unit.OnKilled
	unit.OnKilled = function(self, instigator, type, overkillRatio)
		local player = players[armyTable[scnArmy(self)]]
		--player.unitsremaining = player.unitsremaining - 1
		
		unit.OldOnKilled(self, instigator, type, overkillRatio)	
	end	
end

spawnStartUnits = function()
	for index, player in players do
		if player.ai == false then
			--use player.column to spawn the computer invincible turrets at the right location
			local x = column(player)[1]
			local x2 = column(player)[2]
			local y = 60
			
			local tower = CreateUnitHPR( 'urb2301', toArmy(enemy(player)), x + 10,64,y, 0,0,0) 	
			makeInvincible(tower)
			
			local aa = CreateUnitHPR( 'uab2204', toArmy(enemy(player)), x + 10 ,64,y - 5, 0,0,0) 	
			makeInvincible(aa)
			
			local tower2 = CreateUnitHPR( 'urb2301', toArmy(enemy(player)), x2 - 10 ,64,y, 0,0,0) 	
			makeInvincible(tower2)
			
			local aa2 = CreateUnitHPR( 'uab2204', toArmy(enemy(player)), x2 - 10 ,64,y - 5, 0,0,0) 	
			makeInvincible(aa2)
			
			local powerGen = CreateUnitHPR( 'ueb1301', toArmy(enemy(player)), x - 10 ,64,5, 0,0,0) 
			makeInvincible(powerGen)
			
			local powerGen2 = CreateUnitHPR( 'ueb1301', toArmy(enemy(player)), x - 10 ,64,10, 0,0,0) 
			makeInvincible(powerGen2)
			
			local massFab = CreateUnitHPR( 'uab1303', toArmy(enemy(player)), x - 10 ,64,15, 0,0,0) 
			makeInvincible(massFab)
			
			local omni = CreateUnitHPR( 'uab3104', toArmy(enemy(player)), x - 10 ,64,1, 0,0,0) 
			makeInvincible(omni)
			
			local hq = CreateUnitHPR( 'UEC1101', toArmy(player), column(player)[3],64,ymapsize - 10, 0,0,0) 
			hq:SetMaxHealth(50000)
			hq:SetHealth(nil,50000)
			hq:SetCustomName('Head Quarters: ' .. username(player))
			makeVital(hq)
			
			--powergen
			--omni
			--aa
		end
	end
end

--makes a unit invincible
makeInvincible = function(unit)		
	unit:SetDoNotTarget(true)
	unit:SetCanBeKilled(false)
	unit:SetDoNotTarget(true)
	unit:SetMaxHealth(1)
	unit:SetHealth(nil,1)
	unit:SetRegenRate(1)
end

--if a vital unit you own dies you will lose
makeVital = function(unit)
	unit.OldOnKilled = unit.OnKilled
	unit.OnKilled = function(self, instigator, type, overkillRatio)	
		local army = scnArmy(self)
		local player = players[armyTable[army]]	
		local enemy = enemy(player)
		local enemyarmy = toArmy(enemy)
		player.defeated = true
		scnPrint(username(player) .. " has been crushed by the enemy forces at round " .. waveid .. "!",player)
		local defeatThread = ForkThread(function(self)
			WaitSeconds(5)	
			GetArmyBrain(army):OnDefeat() 	
			GetArmyBrain(enemyarmy):OnDefeat()
			KillThread(self)
		end)
		unit.OldOnKilled(self, instigator, type, overkillRatio)	
	end	
end



--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~MISCALENIOUS FUNCTIONS~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~




--SPECIAL ARMY INITIALISATION: CUSTOM ALLIANCES
function InitializeArmies()
    local tblGroups = {}
    local tblArmy = ListArmies()
	
	local civOpt = ScenarioInfo.Options.CivilianAlliance
    local bCreateInitial = ShouldCreateInitialArmyUnits()
	
	--determine the players depending on which slots are occupied
	for index,army in tblArmy do
		players[armyTable[army]] = playersDATA[armyTable[army]]
	end
	
	--initialise armies
    for iArmy, strArmy in pairs(tblArmy) do
        local tblData = Scenario.Armies[strArmy]

        tblGroups[ strArmy ] = {}

        if tblData then

			--spawn commander and so on
			SetArmyEconomy( strArmy, tblData.Economy.mass, tblData.Economy.energy)

            local armyIsCiv = ScenarioInfo.ArmySetup[strArmy].Civilian

            if toPlayer(strArmy).ai == false then
                local commander = (not ScenarioInfo.ArmySetup[strArmy].Civilian)
                local cdrUnit
                tblGroups[strArmy], cdrUnit = ScenarioUtils.CreateInitialArmyGroup( strArmy, commander)
                if commander and cdrUnit and ArmyBrains[iArmy].Nickname then
                    cdrUnit:SetCustomName( ArmyBrains[iArmy].Nickname )
                end
            end
			
			
			--my function to initialise alliances
            initialiseAlliances()


        end

    end


    return tblGroups
end

--the defender is alone against the attackers
function initialiseAlliances()
	for index,army in ListArmies() do

		--a player is allied to everybody exept its direct enemy
		for index2,army2 in ListArmies() do
			--disable ressource sharing
			GetArmyBrain(army):SetResourceSharing(false)
			if toPlayer(army).ai == true then
				SetArmyColor(armyToIndex(army), toPlayer(army).color[1], toPlayer(army).color[2], toPlayer(army).color[3])			
			end
			--set alliances
			if toPlayer(army2).ai == toPlayer(army).ai then
				SetAlliance( army, army2, 'Ally')
			elseif toPlayer(army2).column == toPlayer(army).column then
				SetAlliance( army, army2, 'Enemy')
			else
				SetAlliance( army, army2, 'Ally')
			end
		end

	end
end


